$LogFile = "C:\XenicaAutoConf\logs\Set_IPs.log"

Function Log {
 Param ([string] $message)
 echo $message
 Add-Content $LogFile -value $message
}
 
log "Setting IPs .."
$base = gwmi -n root\wmi -cl CitrixXenStoreBase 
$sid = $base.AddSession("Xenautostart") 
$session = gwmi -n root\wmi -q "select * from CitrixXenStoreSession where SessionId=$($sid.SessionId)" 
 
# - Network
$ips = @()
$netmasks = @()
$gateways = @()
log "IPs :"
$if_nodes = $session.GetChildren("vm-data/xenica_ifs").children.ChildNodes
foreach ( $if_node in $if_nodes ) {
$node_child = $session.GetChildren("$if_node").children.ChildNodes	
 if ( $node_child -like "*ip6*"){
  $ip6 = $session.GetValue("$if_node/ip6").value
  if ( $ip6 -ne "" ) {
   $netmask6 = $session.GetValue("$if_node/netmask6").value
   $gateway6 = $session.GetValue("$if_node/gateway6").value
   log "$if_node/ip6 : $ip"
   $ips += $ip6
   $netmasks += $netmask6
   $gateways += $gateway6
  }
 }else{
 $ip = $session.GetValue("$if_node/ip").value
 if ( $ip -ne "" ) {
  $netmask = $session.GetValue("$if_node/netmask").value
  $gateway = $session.GetValue("$if_node/gateway").value
  log "$if_node/ip : $ip"
  $ips += $ip
  $netmasks += $netmask
  $gateways += $gateway
 }
 }
}

$ifcfg = Get-WmiObject win32_networkadapterconfiguration | where{$_.IPEnabled -eq "True"}
log "[info] result of  win32_networkadapterconfiguration : $ifcfg"

$ifname = $ifcfg.Description
$ret = $ifcfg.EnableStatic($ips,$netmasks).ReturnValue
if ( $ret -eq 0 ) {
 log "[ok] set IP address on '$ifname' to [$ips]"
}else{
 log "[error] can't set IP address on '$ifname', error code [$ret]"
}

if ( $gateways ) {
 $ret = $ifcfg.SetGateways($gateways).ReturnValue
 if ( $ret -eq 0 ) {
  log "[ok] set gateway on '$ifname' to [$gateways]"
 }else{
  log "[error] can't set gateways on '$ifname', error code [$ret]"
 }
}

Add-Content C:\XenicaAutoConf\logs\need_to_reboot.log -value "reboot"